<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="800px">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="auto"
      v-loading="formLoading"
      class="energy-device-dialog-form"
    >
      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogCheckTimeLabel')" prop="checkTime">
            <el-date-picker
              v-model="formData.checkTime"
              type="date"
              value-format="x"
              :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogCheckTimePlaceholder')"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogCheckValueLabel')" prop="checkValue">
            <el-input-number v-model="formData.checkValue" @change="changeValue" :min="0"  :precision="2" placeholder=""/>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckTimeLabel')" prop="lastCheckTime">
            <el-date-picker
              disabled
              v-model="formData.lastCheckTime"
              type="date"
              value-format="x"
              :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckTimePlaceholder')"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckValueLabel')" prop="lastCheckValue">
            <el-input-number disabled v-model="formData.lastCheckValue" :min="0"  :precision="2" placeholder="" />
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogUnitPriceLabel')" prop="unitPrice">
            <el-input-number v-model="formData.unitPrice" :min="0"  :precision="2" placeholder="" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogDiffValueLabel')" prop="diffValue">
            <el-input-number disabled v-model="formData.diffValue" :min="0"  :precision="2" placeholder="" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogRemarkLabel')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogRemarkPlaceholder')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('EnergyManagement.EnergyDeviceCheck.dialogOkButtonText') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('EnergyManagement.EnergyDeviceCheck.dialogCancelButtonText') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {EnergyDeviceApi, EnergyDeviceVO} from '@/api/mes/energydevice'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  lastCheckTime: undefined,
  lastCheckValue: undefined,
  checkValue: undefined,
  checkTime: undefined,
  diffValue: undefined,
  unitPrice: undefined,
  remark: undefined
})
const formRules = reactive({
  deviceId: [{ required: true, message: t('EnergyManagement.EnergyDeviceCheck.validatorDeviceIdRequired'), trigger: 'blur' }],
  checkValue: [{ required: true, message: t('EnergyManagement.EnergyDeviceCheck.validatorCheckValueRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref


/** 打开弹窗 */
const open = async (type: string, id?: number, deviceId: number, deviceType: string) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type) +':'+ deviceType+'抄表'
  formType.value = type
  resetForm()
  formData.value.deviceId = deviceId
  const data = await EnergyDeviceApi.getEnergyDevice(deviceId)
  formData.value.lastCheckValue = data.lastCheckValue
  formData.value.lastCheckTime = data.lastCheckTime


}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await EnergyDeviceApi.createEnergyDeviceCheckRecord(data)
      message.success(t('common.createSuccess'))
    } else {
      await EnergyDeviceApi.updateEnergyDeviceCheckRecord(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    lastCheckTime: undefined,
    lastCheckValue: undefined,
    checkValue: undefined,
    checkTime: undefined,
    diffValue: undefined,
    unitPrice: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}

const changeValue = () => {
  if(!formData.value.lastCheckValue)
    formData.value.diffValue =formData.value.checkValue;
}
</script>
